//****************************************************************************
// c7Segments_.h                 standard place to store : ..\mcucpp\drivers
//****************************************************************************
// based on max7219.c        (c) Peter Dannegger
//****************************************************************************
	#ifndef _7SEGMENTS_HPP
	#define _7SEGMENTS_HPP

	#include <flashptr.h>           // PROGMEM, FLASH_PTR

	namespace Mcucpp {
//****************************************************************************

	enum add_char {
// *********************************
//	additional characters
// *********************************
			space     =  16,
			minus     =  17,
			degree    =  18,
			c         =  19,
			r         =  20,
			o         =  21,
			H         =  22,
			L         =  23,
			underline =  24,
			upperline =  25,
			P         =  26,
			U         =  27,
			invU      =  28,
			n         =  29,
			exp       =  30,
			Y         =  04,
			S         =  05,
			decPoint  =  0x80
	};


	enum e7Segments_ABC_DEFG {
//*******************************************************
	                        //|7654'3210|      |_ABC'DEFG|
	//*****************************************************
				_A    = 0x40,     //|0100'0000|        ___A___
				_B    = 0x20,     //|0010'0000|       |       |
				_C    = 0x10,     //|0001'0000|       F       B
				_D    = 0x08,     //|0000'1000|       |___G___|
				_E    = 0x04,     //|0000'0100|       |       |
				_F    = 0x02,     //|0000'0010|       E       C
				_G    = 0x01,     //|0000'0001|       |___D___| [DP]
				_DP   = 0x80,     //|1000'0000|
				_NULL = 0x00      //|0000'0000|
	//******************************************************
	};
	
/*	enum class e7Segments_GFE_DCBA {
// *******************************************************
	                        //|7654'3210|      |_ABC'DEFG|
	// *****************************************************
				_G    = 0x40,     //|0100'0000|        ___A___
				_F    = 0x20,     //|0010'0000|       |       |
				_E    = 0x10,     //|0001'0000|       F       B
				_D    = 0x08,     //|0000'1000|       |___G___|
				_C    = 0x04,     //|0000'0100|       |       |
				_B    = 0x02,     //|0000'0010|       E       C
				_A    = 0x01,     //|0000'0001|       |___D___| [DP]
				_DP   = 0x80,     //|1000'0000|
				_NULL = 0x00      //|0000'0000|
	// ******************************************************
	};                                                      */

	class c7Segments_ {
//*****************************************************************************
	public:

	static uint8_t charMap (uint8_t _char) {
//**************************************
		static const uint8_t PROGMEM charset[] = { 
	//************************************************
	//				[0]..[F]                digit      hex
	//************************************************
			_A+_B+_C+_D+_E+_F   ,      // [0]         7e
				 _B+_C            ,      // [1]         30
			_A+_B+   _D+_E+   _G,      // [2]         6d
			_A+_B+_C+_D+      _G,      // [3]         79
				 _B+_C+      _F+_G,      // [4]         33
			_A+   _C+_D+   _F+_G,      // [5]         5b
			_A+   _C+_D+_E+_F+_G,      // [6]         5f
			_A+_B+_C            ,      // [7]         70
			_A+_B+_C+_D+_E+_F+_G,      // [8]         7f
			_A+_B+_C+_D   +_F+_G,      // [9]         7b
			_A+_B+_C+   _E+_F+_G,      // [A]         77
						_C+_D+_E+_F+_G,      // [b]         1f
			_A+      _D+_E+_F   ,      // [C]         4e
				 _B+_C+_D+_E+   _G,      // [d]         3d
			_A+      _D+_E+_F+_G,      // [E]         4f
			_A+         _E+_F+_G,      // [F]         47
										 _NULL,      // [space]     00
												_G,      // [minus]     01
			_A+_B+         _F+_G,      // [degree]    63
							 _D+_E+   _G,      // [c]         0d
									_E+   _G,      // [r]         05
						_C+_D+_E+   _G,      // [o]         1d
				 _B+_C+   _E+_F+_G,      // [H]         3
							 _D+_E+_F   ,      // [L]         0e
							 _D         ,      // [underline] 08
			_A                  ,      // [upperline] 40
			_A+_B+      _E+_F+_G,      // [P]         67
				 _B+_C+_D+_E+_F   ,      // [U]         3e
			_A+_B+_C+   _E+_F   ,      // [invU]      76
					  _C+   _E+   _G,      // [n]         29
			_A+_B         +_F          // [exp]       23
	//************************************************
		};
		FLASH_PTR(uint8_t) _charPtr(charset);
		return  *(_charPtr + size_t(_char));
	}
};

} //.Mcucpp_________________________________________________________________
#endif


