//****************************************************************************
// cClock
//****************************************************************************
// based on clock.c          (c) Peter Dannegger
//****************************************************************************

	#ifndef CLOCK_HPP
	#define CLOCK_HPP
	
	#include<avr/pgmspace.h>    // PROGMEM

	namespace Mcucpp {
//****************************************************************************

	typedef struct	{
//*************************
		uint8_t second;
		uint8_t minute;
		uint8_t hour;
		uint8_t day;
		uint8_t wday;
		uint8_t month;
		uint8_t year;
//*************************
	} sTimeDate;

	const uint8_t PROGMEM MDAYS[] {
		29, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

	template < class Display,        // display
						 class TimeBase        // precise second
//***********************************
> class cClock {
//****************************************************************************
	public:
		static sTimeDate _timedate;

	static void clock(void) {
//********************************************************
		uint8_t i;

		_timedate.second++;
		if( _timedate.second == 60 ) {                      // min passed
				_timedate.second  =  0;
				TimeBase::_timeflags = 1<<TimeBase::ONE_MINUTE; // reload PER MINUTE
				_timedate.minute++;
				if( _timedate.minute == 60 ) {                  // hour passed
						_timedate.minute = 0;
						_timedate.hour++;
					
					switch( _timedate.hour ) {
				//************************************************
					case 24: // o'clock
				//************************************************
						_timedate.hour = 0;                         // day passed
						_timedate.day++;
						_timedate.wday++;
						if( _timedate.wday == 8 ) 
								_timedate.wday = 1;
							
						i = _timedate.month;
						if( i == 2 && (_timedate.year & 3) == 0 ) 
								i =  0;                                 // leap year
						if( LPM(MDAYS+1) == _timedate.day ) {
							_timedate.day = 1;                        // month passed
							_timedate.month++;
							if( _timedate.month == 13 ) {             // year passed
									_timedate.month  =  1;
									_timedate.year++;
									if( _timedate.year == 100 )
											_timedate.year  =   0;            // century passed
							}
						} break;
				 /************************************************
					case 2:; // o'clock
					************************************************
					break;
					
					************************************************
					case 3:; // o'clock                           //summertime()
					************************************************
					break;                                        */
					}
				}
		}
	}

	static void displayDate( ) {           // unused
//**************************************************
		Display::SetDisplayMem(7,_timedate.day	 / 10);
		Display::SetDisplayMem(6,_timedate.day	 % 10|decPoint);
		Display::SetDisplayMem(5,_timedate.month / 10);
		Display::SetDisplayMem(4,_timedate.month % 10|decPoint);
		Display::SetDisplayMem(3, 2);
		Display::SetDisplayMem(2, 0);
		Display::SetDisplayMem(1,_timedate.year / 10);
		Display::SetDisplayMem(0,_timedate.year % 10);
		Display::Update();
	} 

	static void displayTime( ) {
//*************************************************
		Display::SetDisplayMem(7,_timedate.hour   / 10);
		Display::SetDisplayMem(6,_timedate.hour   % 10);
		Display::SetDisplayMem(5, minus);
		Display::SetDisplayMem(4,_timedate.minute / 10);
		Display::SetDisplayMem(3,_timedate.minute % 10);
		Display::SetDisplayMem(2, minus);
		Display::SetDisplayMem(1,_timedate.second / 10);
		Display::SetDisplayMem(0,_timedate.second % 10);
		Display::Update();
	}

	static void displaySync( ) {
//*************************************************
		Display::SetDisplayMem(7,underline^decPoint);  // _.
		Display::SetDisplayMem(6,underline^decPoint);  // _.
		Display::SetDisplayMem(5,underline^decPoint);  // _.
		Display::SetDisplayMem(4,S);                   // S
		Display::SetDisplayMem(3,Y);                   // Y
		Display::SetDisplayMem(2,n);                   // n
		Display::SetDisplayMem(1,c^decPoint);          // c.
		Display::SetDisplayMem(0,underline^decPoint);  // _.
		Display::Update();
	}
};

//____________________________________________________________________________
} //.Mcucpp
#endif
